//
//  AGFoundation.h
//  AGFoundation
//
//  Created by Andrew Garn on 14/06/2012.
//  Copyright (c) 2012 Andrew Garn. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  1. Redistributions of source code must retain the above copyright notice, this
//  list of conditions and the following disclaimer.
//  2. Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the following disclaimer in the documentation
//  and/or other materials provided with the distribution.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
//  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
//  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
//  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#ifndef _AGFOUNDATION_
#define _AGFOUNDATION_

#pragma mark Audio ToolBox

#import "AGSoundEffect.h"

#pragma mark - Core Location

#pragma mark - Foundation 

#import "NSArray+AGCategory.h"
#import "NSBundle+AGCategory.h"
#import "NSDate+AGCategory.h"
#import "NSDictionary+AGCategory.h"
#import "NSFileManager+AGCategory.h"
#import "NSMutableArray+AGCategory.h"
#import "NSMutableDictionary+AGCategory.h|
#import "NSNotificationCenter+AGCategory.h"
#import "NSNumber+AGCategory.h"
#import "NSObject+AGCategory.h"
#import "NSString+AGCategory.h"
#import "NSTimer+AGCategory.h"
#import "NSURL+AGCategory.h"
#import "NSUserDefaults+AGCategory.h"

#import "AGBlockOperation.h"

#pragma mark - MapKit

#import "MKMapView+AGCategory.h"

#pragma mark - MessageUI

#import "AGMailComposeViewController.h"
#import "AGMessageComposeViewController.h"

#pragma mark - StoreKit

#import "SKProduct+AGCategory.h"

#pragma mark - SystemConfiguration



#pragma mark - UIKit

#import "UIAlertView+AGCategory.h"
#import "UIApplication+AGCategory.h"
#import "UIBarButtonItem+AGCategory.h"
#import "UIButton+AGCategory.h"
#import "UIColor+AGCategory.h"
#import "UIControl+AGCategory.h"
#import "UIDevice+AGCategory.h"
#import "UIFont+AGCategory.h"
#import "UIGestureRecognizer+AGCategory.h"
#import "UIImage+AGCategory.h"
#import "UIImageView+AGCategory.h"
#import "UINavigationBar+AGCategory.h"
#import "UINavigationController+AGCategory.h"
#import "UIScreen+AGCategory.h"
#import "UIView+AGCategory.h"

#import "AGActionSheet.h"
#import "AGActivityIndicator.h"
#import "AGAlertView.h"
#import "AGImagePickerController.h"
#import "AGViewController.h"

#pragma mark - Macros

#import "AGCommonMacros.h"
#import "AGDebuggingMacros.h"
#import "AGExceptionHandling.h"
#import "AGPreprocessorMacros.h"
#import "AGSynthesizeSingleton.h"

#endif /* _AGFOUNDATION_ */